"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

var _propTypes = require("prop-types");

var _propTypes2 = _interopRequireDefault(_propTypes);

var _DayPickerInput = require("react-day-picker/DayPickerInput");

var _DayPickerInput2 = _interopRequireDefault(_DayPickerInput);

var _moment = require("react-day-picker/moment");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var ReactDatePicker = function (_Component) {
  _inherits(ReactDatePicker, _Component);

  function ReactDatePicker(props) {
    _classCallCheck(this, ReactDatePicker);

    var _this = _possibleConstructorReturn(this, (ReactDatePicker.__proto__ || Object.getPrototypeOf(ReactDatePicker)).call(this, props));

    _this.handleKeyDown = function (evt) {
      if (evt.keyCode === 13) {
        _this.refs.datePicker.getInput().blur();
      }
    };

    _this.handleBlur = function () {
      var day = _this.day;
      var _this$props = _this.props,
          _this$props$schema$fo = _this$props.schema.format,
          format = _this$props$schema$fo === undefined ? "date-time" : _this$props$schema$fo,
          onChange = _this$props.onChange;

      if (day === undefined) {
        onChange(undefined);
      } else if (format === "date-time") {
        onChange(day.toISOString());
      } else if (format === "date") {
        onChange("" + day.toISOString().substr(0, 10));
      }
    };

    _this.handleDayChange = function (day) {
      _this.day = day;
    };

    var formData = props.formData;


    _this.day = formData ? new Date(formData) : undefined;
    return _this;
  }

  _createClass(ReactDatePicker, [{
    key: "componentWillReceiveProps",
    value: function componentWillReceiveProps(_ref) {
      var formData = _ref.formData;

      if (formData) {
        this.day = new Date(formData);
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _props = this.props,
          _props$uiSchema = _props.uiSchema,
          uiSchema = _props$uiSchema === undefined ? {} : _props$uiSchema,
          formData = _props.formData;
      var _uiSchema$rdp = uiSchema.rdp,
          rdp = _uiSchema$rdp === undefined ? {} : _uiSchema$rdp;

      var dayPickerInputProps = Object.assign({
        onDayChange: this.handleDayChange,
        value: formData ? new Date(formData) : undefined,
        hideOnDayClick: true,
        ref: "datePicker",
        format: "YYYY-MM-DD",
        formatDate: _moment.formatDate,
        inputProps: {
          className: "form-control",
          type: "text",
          autoFocus: uiSchema["ui:autofocus"]
        }
      }, rdp);
      dayPickerInputProps.inputProps.onBlur = this.handleBlur;

      return _react2.default.createElement(
        "div",
        { onKeyDown: this.handleKeyDown },
        _react2.default.createElement(_DayPickerInput2.default, dayPickerInputProps)
      );
    }
  }]);

  return ReactDatePicker;
}(_react.Component);

exports.default = ReactDatePicker;


ReactDatePicker.propTypes = {
  schema: _propTypes2.default.shape({
    format: _propTypes2.default.oneOf(["date-time", "date"])
  })
};